//
// API.c
// APIW߂܂B
//

#include "StdAfx.h"

//R\[F֘A
static HANDLE hStdout;
static CONSOLE_SCREEN_BUFFER_INFO csbi;

void ConsoleBegin(){
	hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(hStdout, &csbi);
}
void ConsoleEnd(){SetConsoleTextAttribute(hStdout, csbi.wAttributes);}
//void ConsoleColor(WORD Color){
//	SetConsoleTextAttribute(hStdout, Color);
//}
void ConsoleGreen(){SetConsoleTextAttribute(hStdout, FOREGROUND_GREEN|FOREGROUND_INTENSITY);}
void ConsoleRed(){SetConsoleTextAttribute(hStdout, FOREGROUND_RED|FOREGROUND_INTENSITY);}
void ConsoleBlue(){SetConsoleTextAttribute(hStdout, FOREGROUND_BLUE|FOREGROUND_INTENSITY);}
void ConsoleYellow(){SetConsoleTextAttribute(hStdout, FOREGROUND_GREEN|FOREGROUND_RED|FOREGROUND_INTENSITY);}
void ConsoleAqua(){SetConsoleTextAttribute(hStdout, FOREGROUND_GREEN|FOREGROUND_BLUE|FOREGROUND_INTENSITY);}
void ConsolePurple(){SetConsoleTextAttribute(hStdout, FOREGROUND_RED|FOREGROUND_BLUE|FOREGROUND_INTENSITY);}
void ConsoleWhite(){SetConsoleTextAttribute(hStdout, FOREGROUND_GREEN|FOREGROUND_RED|FOREGROUND_BLUE|FOREGROUND_INTENSITY);}

/////////////////

void Version_OSVer(){
	char* OS = NULL;
	OSVERSIONINFO osVersionInfo;
	NullMemory(&osVersionInfo,sizeof(OSVERSIONINFO));
	osVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osVersionInfo);

	switch(GetOSType()){
		case WIN31:			OS="3.1";				break;
		case WIN95OSR1:		OS="95 OSR1";			break;
		case WIN95OSR2:		OS="95 OSR2";			break;
		case WIN95OSR25:	OS="95 OSR2.5";			break;
		case WIN98:			OS="98";				break;
		case WIN98SE:		OS="98 Second Edition";	break;
		case WINNT3:		OS="NT 3.5";			break;
		case WINNT4:		OS="NT 4.0";			break;
		case WIN2K:			OS="2000";				break;
		case WINXP:			OS="XP";				break;
		case WIN2K3:		OS="2003";				break;
		case WINVISTA:		OS="Vista";				break;
		default:			OS="Unknown";			break;
	}

	if (OS)
	printf("Windows %s Version %d.%d Build %d\n",OS,
			osVersionInfo.dwMajorVersion,
			osVersionInfo.dwMinorVersion,
			osVersionInfo.dwBuildNumber & 0xffff);
}

void Version_IEVer(){
	DWORD	dwType=REG_SZ;
	ULONG	nSize=256;
	HKEY	hKey=NULL;
	BYTE	lpszBuff[300];

	RegOpenKeyEx(HKEY_LOCAL_MACHINE
		,"Software\\Microsoft\\Internet Explorer"
		,0,KEY_ALL_ACCESS,&hKey);
	RegQueryValueEx(hKey,"Version",NULL,&dwType,lpszBuff,&nSize);
	RegCloseKey(hKey);

	if(*lpszBuff)
		printf("Internet Explorer %s\n",(char*)lpszBuff);
}

void SetFunc(LPCSTR szDll,LPSTR szCmd, LPSTR szGV){
	//֐ݒ

	char szDll1[30];
	int l=lstrlen(szDll),i=0;
	//lstrcpy(szCmd,"");
	//lstrcpy(szGV,"");
	*szCmd = 0;
	*szGV = 0;

	//.DLL⊮B
	lstrcpy(szDll1,CharUpper((char*)szDll));
	for(;i<l;i++)
		if(szDll1[i]=='.')break;
	if(i==l) lstrcat(szDll1,".DLL");


	lstrcpy(szCmd,
		!lstrcmp(szDll1,CharUpper(UNLHA32DLL))	? UNLHA32PRE	:
		!lstrcmp(szDll1,CharUpper(IUNLHA32DLL))	? IUNLHA32PRE	:
		!lstrcmp(szDll1,CharUpper(UNZIP32DLL))	? UNZIP32PRE	:
		!lstrcmp(szDll1,CharUpper(ZIP32JDLL))	? ZIP32JPRE		:
		!lstrcmp(szDll1,CharUpper(LMZIP32DLL))	? LMZIP32PRE	:
		!lstrcmp(szDll1,CharUpper(CAB32DLL))	? CAB32PRE		:
		!lstrcmp(szDll1,CharUpper(UNARJ32JDLL))	? UNARJ32JPRE	:
		!lstrcmp(szDll1,CharUpper(TAR32DLL))	? TAR32PRE		:
		!lstrcmp(szDll1,CharUpper(BGA32DLL))	? BGA32PRE		:
		!lstrcmp(szDll1,CharUpper(UNBEL32DLL))	? UNBEL32PRE	:
		!lstrcmp(szDll1,CharUpper(UNGCA32DLL))	? UNGCA32PRE	:
		!lstrcmp(szDll1,CharUpper(YZ1DLL))		? YZ1PRE		:
		!lstrcmp(szDll1,CharUpper(UNYZ1DLL))	? UNYZ1PRE		:
		!lstrcmp(szDll1,CharUpper(YYZ32DLL))	? YZ1PRE		:
		!lstrcmp(szDll1,CharUpper(YZ2DLL))		? YZ2PRE		:
		!lstrcmp(szDll1,CharUpper(UNRAR32DLL))	? UNRAR32PRE	:
		!lstrcmp(szDll1,CharUpper(UNACE32DLL))	? UNACE32PRE	:
		!lstrcmp(szDll1,CharUpper(UNACEV2JDLL))	? UNACEV2JPRE	:
		!lstrcmp(szDll1,CharUpper(ACE32DLL))	? ACE32PRE		:
		!lstrcmp(szDll1,CharUpper(SVZIP32DLL))	? SVZIP32PRE	:
		!lstrcmp(szDll1,CharUpper(KB7ZDLL))		? SVZIP32PRE	:
		!lstrcmp(szDll1,CharUpper(UNIMP32DLL))	? UNIMP32PRE	:
		!lstrcmp(szDll1,CharUpper(FTP32DLL))	? FTP32PRE		:
		!lstrcmp(szDll1,CharUpper(ISH32DLL))	? ISH32PRE		:
		!lstrcmp(szDll1,CharUpper(DMISH32DLL))	? ISH32PRE		:
		!lstrcmp(szDll1,CharUpper(DMISHDLL))	? DMISHPRE		:
		!lstrcmp(szDll1,CharUpper(AISH32DLL))	? AISH32PRE		:
		!lstrcmp(szDll1,CharUpper(AISHMV32DLL))	? AISHMV32PRE	:
		!lstrcmp(szDll1,CharUpper(UNKANJDLL))	? CCPRE			:
		!lstrcmp(szDll1,CharUpper(JACK32DLL))	? JACK32PRE		:
		!lstrcmp(szDll1,CharUpper(BH32DLL))		? BH32PRE		:
		!lstrcmp(szDll1,CharUpper(NOA32WDLL))	? NOA32WPRE		:
		!lstrcmp(szDll1,CharUpper(NOA32DLL))	? NOA32PRE		:
		!lstrcmp(szDll1,CharUpper(UNHKI32DLL))	? UNHKI32PRE	:
		!lstrcmp(szDll1,CharUpper(DZ32DLL))		? DZ32PRE		:
		//!lstrcmp(szDll1,CharUpper(HA32DLL))		? HA32PRE		:
		!lstrcmp(szDll1,CharUpper(UNPMA32DLL))	? UNPMA32PRE	:

		!lstrcmp(szDll1,CharUpper(KTY32DLL))	? KTY32PRE		:
		!lstrcmp(szDll1,CharUpper(ZZIP32DLL))	? ZZIP32PRE		:
		!lstrcmp(szDll1,CharUpper(UNALZ32DLL))	? UNALZ32PRE	:
		!lstrcmp(szDll1,CharUpper(SQX32DLL))	? SQX32PRE		:
		!lstrcmp(szDll1,CharUpper(UNARCDLL))	? UNARCPRE		:
		!lstrcmp(szDll1,CharUpper(UNZOODLL))	? UNZOOPRE		:
		!lstrcmp(szDll1,CharUpper(UNZOO32DLL))	? UNZOO32PRE	:
		!lstrcmp(szDll1,CharUpper(RK32DLL))		? RK32PRE		:
		!lstrcmp(szDll1,CharUpper(ARCEXTJDLL))	? ARCEXTJPRE	:
		!lstrcmp(szDll1,CharUpper(PAQAR32DLL))	? PAQAR32PRE	:
		//!lstrcmp(szDll1,CharUpper(PAQ32DLL))	? PAQ32PRE	:
		!lstrcmp(szDll1,CharUpper(OAR32DLL))	? OAR32PRE		:

		!lstrcmp(szDll1,CharUpper(APLIBDLL))	? APLIBPRE		:
		!lstrcmp(szDll1,CharUpper(JCALG32DLL))	? JCALG32PRE	:
		!lstrcmp(szDll1,CharUpper(BRIEFLZDLL))	? BRIEFLZPRE	:
		!lstrcmp(szDll1,CharUpper(UCL32DLL))	? UCL32PRE		:
		!lstrcmp(szDll1,CharUpper(ZLP32DLL))	? ZLP32PRE		:
		!lstrcmp(szDll1,CharUpper(SPL32DLL))	? SPL32PRE		:
		!lstrcmp(szDll1,CharUpper(LZ32JDLL))	? LZ32JPRE		:
		!lstrcmp(szDll1,CharUpper(BASE64ARCDLL))? BASE64ARCPRE	:
		!lstrcmp(szDll1,CharUpper(JAM32DLL))	? JAM32PRE		:
		!lstrcmp(szDll1,CharUpper(UNJAM32DLL))	? UNJAM32PRE	:
		!lstrcmp(szDll1,CharUpper(JPZ32DLL))	? JPZ32PRE		:
		!lstrcmp(szDll1,CharUpper(SHELLCADLL))	? SHELLCAPRE	:
		!lstrcmp(szDll1,CharUpper(CRYPTZIPDLL))	? CRYPTZIPPRE	:
		!lstrcmp(szDll1,CharUpper(NKFDLL))		? NKFPRE		:
		!lstrcmp(szDll1,CharUpper(REDUCEPEDLL))	? REDUCEPEPRE	:
		!lstrcmp(szDll1,CharUpper(WINEXDLL))	? WINEXPRE		:
		!lstrcmp(szDll1,CharUpper(HALDELPHICADLL))	? HALDELPHICAPRE	:
		!lstrcmp(szDll1,CharUpper(CASPI32DLL))	? CASPI32PRE	:
		!lstrcmp(szDll1,CharUpper(SPIDLL))		? SPIPRE		:
		!lstrcmp(szDll1,CharUpper(XACRETTDLL))	? XACRETTPRE	:
		//!lstrcmp(szDll1,CharUpper(LZA32DLL))	? LZA32PRE		:
		//!lstrcmp(szDll1,CharUpper(RS32DLL))		? RS32PRE		:
		//!lstrcmp(szDll1,CharUpper(SIT32DLL))	? SIT32PRE		:
		//!lstrcmp(szDll1,CharUpper(UNLBR32DLL))	? UNLBR32PRE	:
		//!lstrcmp(szDll1,CharUpper(UNARC32DLL))	? UNARC32PRE	:
		//!lstrcmp(szDll1,CharUpper(NULIB32DLL))	? NULIB32PRE	:
		!lstrcmp(szDll1,CharUpper(UNHKI32XDLL))	? UNHKI32PRE	:
		!lstrcmp(szDll1,CharUpper(UNHKI32JDLL))	? UNHKI32PRE	:
		//!lstrcmp(szDll1,CharUpper(UNACE32JDLL))	? UNACE32PRE	:
		"");

	if(!(*szCmd))
	lstrcpy(szGV,
		!lstrcmp(szDll1,CharUpper(UNRARDLL))	? "RARGetDllVersion"	:
		!lstrcmp(szDll1,CharUpper(IZIP32JDLL))	? "IZip32JGetVersion"	:
		!lstrcmp(szDll1,CharUpper(ZCRYPT32DLL))	? "ZCrypt32GetVersion"	:
		!lstrcmp(szDll1,CharUpper(BZ2LIBDLL))	? "BZ2GetVersion"		:
		!lstrcmp(szDll1,CharUpper(WINEX32DLL))	? "WinExGetVersion"		:
		!lstrcmp(szDll1,CharUpper(NOADLL))		? "NoaGetVersion"		:
		!lstrcmp(szDll1,CharUpper(ZIPDLL))		? "GetZipDllVersion"	:
		!lstrcmp(szDll1,CharUpper(UNZDLL))		? "GetUnzDllVersion"	:
		!lstrcmp(szDll1,CharUpper(ZLIBDLL))		? "zlibVersion"			:
		//!lstrcmp(szDll1,CharUpper(ARCEXTDLL))	? "ArcextGetVersion"	:
		!lstrcmp(szDll1,CharUpper(JRE32DLL))	? "JreGetVersion"		:
		!lstrcmp(szDll1,CharUpper(NKF32DLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(ZIP32DLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(ARC32DLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(ACEV2DLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(UNACEV2DLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(UNACEDLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(CABINETDLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(SQXDLL))		? CCPRE	:
		!lstrcmp(szDll1,CharUpper(ZZLIBDLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(STUFFITDLL))	? STUFFVER	:
		!lstrcmp(szDll1,CharUpper(GOGODLL))		? CCPRE	:
		!lstrcmp(szDll1,CharUpper(RCPCVDLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(VVWEBOCX))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(CHROMADLL))	? CCPRE	:
		!lstrcmp(szDll1,CharUpper(LONGINUSDLL))	? CCPRE	:
		"");
}

void Main_Showlogo(){
	ConsoleBlue();
	printf(
		">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n");
	ConsoleGreen();
	printf(
		"CLA -CommandLineArchiver- 3.99 Beta%d\n\n",CLAVersion);
	ConsoleYellow();
	printf(
		"Copyright (C) HAL \"Minthe\" Pussywillow\n"
		"Under zlib/libpng license.\n");
	ConsoleAqua();
	printf(
		"http://f50.aaa.livedoor.jp/~minthe/pukiwiki/\n"
		"cinnamon@hal.tn.st\n");
	ConsoleBlue();
	printf(
		"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<\n\n");
	ConsoleGreen();
}

void Main_Support(){
	ConsoleYellow();
	printf(
		"%s:\n"
		"Unlha32.dll/UnZip32.dll/Zip32j.dll/Cab32.dll/Unarj32j.dll/Tar32.dll/\n"
		"Bga32.dll/Unbel32.dll/UnGCA32.dll/Yz1.dll/UnYz1.dll/Yyz32.dll/\n"
		"Unrar32.dll/7-zip32.dll/UnImp32.dll/Kty32.dll/Zzip32.dll/Unace32.dll/\n"
		"Ftp32.dll/Aish32.dll/Aishmv32.dll/Ish32.dll/DmIsh32.dll/DmIsh.dll/Unkanj.dll/\n"
		"Jack32.dll/Yz2.dll/iunlha32.dll/Caspi32.dll/XacRett.dll/Sqx32.dll/Yyz.dll/\n"
		"Bh32.dll/Unarc.dll/Aplib.dll/Jcalg32.dll/Jam32.dll/Unjam32.dll/UnZoo32.dll/\n"
		"Paqar32.dll/Jpz32.dll/CryptZip.dll/Nkf.dll/ReducePE.dll/WinEx.dll/\n"
		"HALDelphiCA.dll/LMZip32.dll/Unzoo.dll/Noa32.dll/BriefLZ.dll/\n"
		"DCab32.dll/QBga32.dll/funzip32.dll/kb7z.dll/Rk32.dll/UnHki32.dll/\n"
		"NOA32w.dll/Dz32.dll/Ucl32.dll/Zlp32.dll/Lz32j.dll/Ace32.dll/UnAceV2J.dll/\n"
		"ArcExtJ.dll/ShellCa.dll/Spi.dll/Oar32.dll/UnAlz32.dll/\n"
		"Base64Arc.dll/Spl32.dll/UnPma32.dll\n",
		ConsoleIsJP()?"CLAT|[gDLL":"CLA supports");
	ConsoleGreen();
	printf(
		"(Only Version Info)\n"
		"UnRAR.dll/IZip32j.dll/ZCrypt32.dll/Bz2lib.dll/WinEx32.dll/noa.dll/\n"
		"Zipdll.dll/Unzdll.dll/Zlib.dll/Arcext.dll/Zip32.dll/AceV2.dll/UnAceV2.dll/\n"
		"stuffit5.engine-5.1.dll/Arc32.dll/Sqx.dll/Cabinet.dll/VvWeb.ocx/chromakey.dll/\n"
		"Longinus.dll/msiexec.exe/Jre32.dll\n"
		"(Only Exist)\n"
		"Unace.dll/Nkf32.dll/gogo.dll/Zzlib.dll/rcpcv.dll\n");
}


void Main_Usage(){
	ConsoleAqua();
	printf(
		"Usage:\n"
		"CLA <[-|/]option...> <Library> <Command>\n\n"
		"Options:\n"
		"/n : Nologo  /p : Pause\n"
		"// : Force to parse command\n"
		"/m<h|c|o|f|i|l> : working Mode\n"
		"(cHeck|Conf|cOunt|Func|Info|List)\n"
		"/v<1|2|3|4|5>   : getVersion\n"
		"/c<1|2|3>       : Checkarchive\n"
		"/f<1|2>         : queryFunctionlist\n"
		"/a<API>         : specify API prefix\n"
		"%s\n\n"
		"Example:\n"
		"CLA /n /p /v\n"
		"CLA /c 1.zip\n"
		"CLA /f 51\n"
		"CLA /p %s a 1.lzh 1.txt\n"
		"CLA /mc %s\n"
		"CLA /mo /p %s 1.7z\n"
		"CLA /mf %s 31\n"
		"CLA /p /mh %s 1.tar.bz2 all\n\n",
		ConsoleIsJP()
			?"///v/c/fIƁAR}hC͂͏I܂"
			:"If you choose <//|/v|/c|/f>, parsing will end.",
		UNLHA32DLL,UNZIP32DLL,SVZIP32DLL,
		YZ1DLL,TAR32DLL);
}

void Main_Pause(){
	ConsolePurple();
	printerr("\nPress Enter Key");
	ReadFile(GetStdHandle(STD_INPUT_HANDLE),NULL,1,NULL,NULL);
}

//Are there any spaces?
bool SpaceThere(LPCSTR szString){
	int i=0,l=lstrlen(szString);
	for (; i<l; i++){
		if (szString[i]==' ')
			return true;
	}
	return false;
}

char* pszDateTimes(WORD wDate,WORD wTime){
  static char szDateTime[22];
  wsprintf(szDateTime, "%04u/%02u/%02u %02u:%02u:%02u",
          (wDate >> 9) + 1980, (wDate >> 5) & 0x0F, (wDate & 0x1F),
          (wTime >> 11), (wTime >> 5) & 0x3F, (wTime & 0x1F) * 2);
  return szDateTime;
}

void Version_Stuffver(){
	WORD a,b,c,d;
	char szVerstr[28];
	Getversion fpGetVersion;
	HMODULE hDll = LoadLibrary("stuffit5.engine-5.1.dll");
	if (hDll){
		wsprintf(szVerstr,"%s%s",STUFFVER,"majorv");
		fpGetVersion = (Getversion)GetProcAddress(hDll,szVerstr);
		a=fpGetVersion();
		wsprintf(szVerstr,"%s%s",STUFFVER,"minorv");
		fpGetVersion = (Getversion)GetProcAddress(hDll,szVerstr);
		b=fpGetVersion();
		wsprintf(szVerstr,"%s%s",STUFFVER,"patchlevel");
		fpGetVersion = (Getversion)GetProcAddress(hDll,szVerstr);
		c=fpGetVersion();
		wsprintf(szVerstr,"%s%s",STUFFVER,"build");
		fpGetVersion = (Getversion)GetProcAddress(hDll,szVerstr);
		d=fpGetVersion();
		printf("%d.%d.%d.%d",a,b,c,d);
	}else{
		ConsolePurple();
		printf("---------");
	}
	FreeLibrary(hDll);	
}

void Version_StuffitVersion(){
	printf("stuffit5.engine-5.1.dll ");
	ConsoleYellow();
	Version_Stuffver();
	ConsoleAqua();
	printf(" (C) Allume Systems\n");
}

int CollectUnZip(){
/*
UnZip32.dll[h
MicUnZipGetVersion()Ȃfunzip32
MicUnZipGetVersion()>8000ȂUnZip32
ȊOȂDMZip32
Ԓl
0==UnZip32
1==DMZip32
2==funzip32
3==Not Found
*/
	int result=3;
	HMODULE hDll=LoadLibrary(UNZIP32DLL);
	if (hDll){
		FARPROC fp=GetProcAddress(hDll,MICUZVER);
		result = !fp ? 2 : ((Getversion)fp)()>8000 ? 0 : 1;
	}
	FreeLibrary(hDll);
	return result;
}

int CollectCab(){
/*
_Cab32.dll[hł==DCab32
łȂ==Cab32
Ԓl
0==Cab32
1==DCab32
2==Not Found
*/
	int result=2;
	HMODULE hDll=LoadLibrary("_Cab32");
	result = !!hDll;
	FreeLibrary(hDll);

	if (!(hDll=LoadLibrary(CAB32DLL)))
		result=2;
	FreeLibrary(hDll);
	return result;
}

int CollectBga(){
/*
Bga32.dll[h
QBga32GetVersion()QBga32
ȂBga32
Ԓl
0==Bga32
1==QBga32
2==Not Found
*/
	int result=2;
	HMODULE hDll=LoadLibrary(BGA32DLL);
	if (hDll){
		FARPROC fp=GetProcAddress(hDll,QBGAVER);
		result = !!fp;
	}
	FreeLibrary(hDll);
	return result;
}


//int CollectUnAce(){
/*
UnAce32.dll[h
UnAceGetVersion()UnAce32
ȂUnace32
Ԓl
0==UnAce32
1==Unace32
2==Not Found
*/
/*
	int result=2;
	HMODULE hDll=LoadLibrary(UNACE32DLL);
	if(hDll){
		FARPROC fp=GetProcAddress(hDll,"UnAceGetVersion");
		result = !!fp;
	}
	FreeLibrary(hDll);
	return result;
}*/

BOOL __cdecl ConsoleIsJP(){
	//return (ConsoleCP()==932);

	_asm{
		call dword ptr[GetConsoleCP]
		cmp eax, 932
		jz $OK			; 932 -> !0Ȃ̂ł̂܂ܕԂĂ悢
		xor eax, eax
$OK:
		;ret			; retȂƂA֐̏Iret܂炵
	}
}

int atoi(LPCSTR p){
	int r = 0;

	for(;*p;p++){
		if('0' <= *p && *p <= '9')
			r = r * 10 + *p - '0';
	}
	return r;
}

char* ExtractFileName(LPCSTR szName){
	//From melmel. Thx K.INABA!
	LPCSTR r=szName;

	for(;*szName;szName++){
		if(*szName=='\\'||*szName=='/')
			r = szName+1;
	}

	return (char*)r;
}

//print
//wvsprintf̃obt@1024byte炻̎bI(^^;;;
void print(LPCSTR szString){
	DWORD dwLen;
	WriteFile(hStdout,szString,lstrlen(szString),&dwLen,NULL);
}

//printf
//wvsprintf/WriteFileɂĎĂ܂B
int printf(const char *format, ...){
	char *ch=(char*)GlobalAlloc(GPTR,1024);
	va_list argp;
	DWORD dwLen;

	va_start(argp,format);
	wvsprintf(ch, format, argp);
	va_end(argp);
	//_CNgɑΉł悤A
	//R\[Ƃt@Cɏo(^^;;;
	WriteFile(hStdout,ch,lstrlen(ch),&dwLen,NULL);
	GlobalFree(ch);

	return (signed)dwLen;
}

//stdoutł͂Ȃstderrɏo͂ꍇɎgp
int printerr(const char *format, ...){
	char *ch=(char*)GlobalAlloc(GPTR,1024);
	va_list argp;
	DWORD dwLen;
	//HANDLE hStderr=GetStdHandle(STD_ERROR_HANDLE);

	va_start(argp,format);
	wvsprintf(ch, format, argp);
	va_end(argp);
	//_CNgɑΉł悤A
	//R\[Ƃt@Cɏo(^^;;;
	WriteFile(GetStdHandle(STD_ERROR_HANDLE),ch,lstrlen(ch),&dwLen,NULL);
	GlobalFree(ch);

	return (signed)dwLen;
}
