@echo off

rem ---
rem This test suite uses 7-zip32.dll.
rem
rem You can change LIBRARY variant into any libraries which you'd like to use.
rem However, some libraries fail in the line "CLA /n %LIBRARY%"
rem because they do not accept empty commands.
rem If you'd like to use such libraries, you have to delete/hide the line and the following.
rem ---

set LIBRARY=7-zip32.dll

echo =CLA TestSuite (7-zip32.dll)=

if %1.==. goto err
if not exist %1 goto err

CLA /n /mc %LIBRARY% pack
echo.
CLA /n /mf %LIBRARY% 0
echo.
CLA /n /mi %LIBRARY%
CLA /n /mh %LIBRARY% %1
echo.
CLA /n /mo %LIBRARY% %1
echo.
CLA /n /ml %LIBRARY% %1
echo.
CLA /n %LIBRARY%
echo.

echo Test suite ended correctly.
goto end

:err
echo Please specify an archive for running test suite. (DnD is OK)

:end
pause