//
// CLA.c
// CommandLineArchiver
//

//ZipTV Routine of Bh32.dll:
/**********************************************************************

  Copyright 1998-2004,  Microchip Data Systems / Carl Bunton

  Any revision or distribution of sources or any compiled dll dealing
  with the BlakHole (.bh extension) compression format requires this
  copyright notice be included in the source, documentation, and help
  files.

  Alterations to the BlakHole compressed header format can not be
  made without prior express written consent by the author.

  Web-site:  http://www.ziptv.com
**********************************************************************/

//C(++)ȊǑŏꂽDLLĂяo悤ɁA
//LoadLibrary/GetProcAddress̗p܂B(^^;;;

#include "StdAfx.h"

/*
struct ENTRYCODE{
	unsigned char code[4];
	unsigned long addr;
	unsigned char code2[4];
}entry_code = {
	{0x90,0x90,0x90,			// nop
	0xb8},(unsigned long)Entry,	// mov eax,(unsigned long)Entry
	{0xff,0xe0,0,0}				// jmp eax
};
*/

void Entry(){
	int argc=ArgCount(),i=0,result;
	char *argv[512];
	char *str=(char*)GlobalAlloc(GPTR,FNAME_MAX32+10);

	//argv=(char**)GlobalAlloc(GPTR,sizeof(char*)*(argc+1));
	for(;i<argc;i++){
		lstrcpy(str,Tokenize(i));
		argv[i]=(char*)GlobalAlloc(GPTR,lstrlen(str)+1);
		lstrcpy(argv[i],str);
	}
	GlobalFree(str);
	argv[argc]=NULL;

	result=CLA(argc,argv);
	for (i=0;i<argc;i++)
		GlobalFree(argv[i]);
	//GlobalFree(argv);

	//ExitProcess(result);

	_asm{
		push result
		call dword ptr[ExitProcess]
	}
}

int CLA(int argc, char **argv){
	int  result=0;
	bool bPause=false;
	bool bLogo=true;
	int  iMode=0;
	int  i=1;

	char szCmd[12];
	char szGV[22];
	char szGSV[25];
	char szConf[24];
	char szCheck[23];
	char szCount[23];
	char szFunc[29];

	char szOpen[23];
	char szClose[24];
	char szFirst[21];
	char szNext[20];
	char szDate[22];
	char szTime[22];
	char szRatio[23];
	char szSfx[21];

	char* szMsg;
	BOOL resultbool=FALSE;

	FARPROC fp;
	HMODULE hDLL;
	bool JpCon=ConsoleIsJP();

	ConsoleBegin();
	ConsoleGreen();

	lstrcpy(szCmd,"");

	if (!argv[1]){
		Main_Showlogo();
		ConsoleYellow();
		Main_Usage();
		ConsoleRed();
		printerr(JpCon?"DLLw肳Ă܂\n\n":"Library NOT specified.\n\n");
		ConsoleAqua();
		Main_Support();
		ConsoleEnd();
		return 4;
	}

	for (;i<argc;i++){
		if(argv[i][0]!='-'&&argv[i][0]!='/')break;
		if(argv[i][0]==argv[i][1]){i++;break;}
		switch(argv[i][1]){
			case 'a':
			case 'A':{
			if(argv[i][2]) lstrcpy(szCmd,argv[i]+2);
			}break;
			case 'v':
			case 'V':{
			if(bLogo)Main_Showlogo();
			switch(argv[i][2]){
				case '1':result=GetVersion_Get(0);break;
				case '2':result=GetVersion_Get(GV_1);break;
				case '3':result=GetVersion_Get(GV_1|GV_2);break;
				case '4':result=GetVersion_Get(GV_1|GV_2|GV_3);break;
				default:
				case '5':result=GetVersion_Get(GV_1|GV_2|GV_3|GV_4);break;
			}}break;
			case 'c':
			case 'C':{
			if(bLogo)Main_Showlogo();
			switch(argv[i][2]){
				case '1':result=CheckArchive_Check(argv[++i],1);break;
				case '2':result=CheckArchive_Check(argv[++i],2);break;
				default:
				case '3':result=CheckArchive_Check(argv[++i],3);break;
			}}break;
			case 'f':
			case 'F':{
			if(bLogo)Main_Showlogo();
			switch(argv[i][2]){
				case '1':result=QueryFunc(argv[++i],1);break;
				default:
				case '2':result=QueryFunc(argv[++i],2);break;
			}}break;
			case 'n':case 'N':bLogo=false;break;
			case 'p':case 'P':bPause=true;break;
			//샂[hݒ
			case 'm':
			case 'M':
			switch(argv[i][2]){
				case 'h':case 'H':case '1':iMode=1;break; //cHeck
				case 'c':case 'C':case '2':iMode=2;break; //Conf
				case 'o':case 'O':case '3':iMode=3;break; //cOunt
				case 'f':case 'F':case '4':iMode=4;break; //Func
				case 'i':case 'I':case '5':iMode=5;break; //Info
				case 'l':case 'L':case '6':iMode=6;break; //List
			}break;
		}
		if (result) {
			if (bPause) Main_Pause();
			ConsoleEnd();
			return result-100;
		}
	}
	if(bLogo)Main_Showlogo();

	if (i>=argc){
		ConsoleRed();
		printerr(JpCon?"R}hG[\n\n":"Command Error!\n\n");
		Main_Usage();
		Main_Support();
		if (bPause) Main_Pause();
		ConsoleEnd();
		return 4;
	}

	if (hDLL = LoadLibrary(argv[i])){
		printf("Library: %s\n",argv[i]);

		//֐ݒ
		if (!lstrcmp(szCmd,""))
			SetFunc(ExtractFileName(argv[i]),szCmd,szGV);

		//API擾I
		if (lstrcmp(szCmd,"")){
			if (!lstrcmp(szCmd,UNZIP32PRE)&&CollectUnZip()==1)
				lstrcpy(szGV,MICUZVER);
			else
				wsprintf(szGV,"%s%s",szCmd,GV);
			wsprintf(szGSV  ,"%s%s",szCmd,GSV);
			wsprintf(szCheck,"%s%s",szCmd,CHECK);
			wsprintf(szFunc ,"%s%s",szCmd,FUNC);
			wsprintf(szConf ,"%s%s",szCmd,CONF);
			wsprintf(szCount,"%s%s",szCmd,COUNT);
			wsprintf(szOpen ,"%s%s",szCmd,OPEN);
			wsprintf(szClose,"%s%s",szCmd,CLOSE);
			wsprintf(szFirst,"%s%s",szCmd,FIRST);
			wsprintf(szNext ,"%s%s",szCmd,NEXT);
			wsprintf(szRatio,"%s%s",szCmd,RATIO);
			wsprintf(szDate ,"%s%s",szCmd,DATE);
			wsprintf(szTime ,"%s%s",szCmd,TIME);
			wsprintf(szSfx  ,"%s%s",szCmd,SFX);
			if (!lstrcmp(szCmd,CCPRE))
				lstrcat(szCmd,COM);
			if (!lstrcmp(szCmd,UNYZ1PRE)){
				wsprintf(szGV ,"%s%s",szCmd,UNYZ1GV);
				wsprintf(szGSV,"%s%s",szCmd,UNYZ1GSV);
			}
		}

		if (lstrcmp(szGV,"")){
			//GetVersion
			if (fp = GetProcAddress(hDLL,szGV)){
				WORD v1 = ((Getversion)fp)();
				printf( !lstrcmp(szGV,MICUZVER)
							? "Library Version: %d.%02d (DMZip32.dll)"
							: "Library Version: %d.%02d",
						v1/100,v1%100);
				if (szGSV){
					if (fp = GetProcAddress(hDLL,szGSV)){
						WORD v2 = ((Getversion)fp)();
						printf(".%d.%02d\n\n",v2/100,v2%100);
					}else
						printf("\n\n");
				}else
					printf("\n\n");
			}else if(!lstrcmp(szGV,STUFFVER)){
				printf("Library Version: ");
				Version_Stuffver();
				printf("\n\n");
			}else
				printf("Library Load OK.\n\n");
		}else{
			ConsoleRed();
			printf(JpCon
					?"DLL̓T|[gĂ܂\n\n"
					:"This Library is NOT supported.\n\n");
			Main_Support();
			iMode=-1;
			result=5;
		}

		//DLLłȂΒeB
		if (!lstrcmp(szCmd,"")&&iMode!=-1){
			ConsolePurple();
			printf(JpCon?"DLLCLAł͓삵܂":"This Library cannot function in CLA.");
			iMode=-1;
			result=5;
		}

		if (iMode!=-1&&!(fp=GetProcAddress(hDLL,szCmd))){
			ConsolePurple();
			printf(JpCon?"PrefixԈĂ܂":"Prefix wrong.");
			iMode=-1;
			result=5;
		}

		//֐
		switch(iMode){
			case 1:{
				if (fp = GetProcAddress(hDLL,szCheck)){
					if(argv[++i]){
						ConsoleYellow();
						if(argv[++i]){
								if (!lstrcmp(argv[i],"all")){
									printf("%s() <Check All>\n",CHECK);
									resultbool = ((CheckArchive)fp)(argv[i-1],1);
								}else if (!lstrcmp(argv[i],"crc")){
									printf("%s() <Check CRC>\n",CHECK);
									resultbool = ((CheckArchive)fp)(argv[i-1],2);
								}else{
									printf("%s() <Normal>\n",CHECK);
									resultbool = ((CheckArchive)fp)(argv[i-1],0);
								}
						}else{
								printf("%s() <Normal>\n",CHECK);
								resultbool = ((CheckArchive)fp)(argv[i-1],0);
						}
						if (resultbool){
							ConsoleAqua();
							printf(JpCon?"ɂł":"Correct Archive.");
							result=0;
						}else{
							ConsolePurple();
							printf(JpCon
									?"jĂ邩ɂł͂܂"
									:"Incorrect Archive or Not Archive.");
							result=2;
						}
					}else{
						ConsoleYellow();
						printf("%s()\n",CHECK);
						ConsoleRed();
						printf(JpCon
								?"ɂw肳Ă܂"
								:"Archive is NOT specified.");
						result=1;
					}
				}else{
					ConsoleRed();
					printf(JpCon
							?"%s() ̓T|[gĂ܂"
							:"%s() NOT supported.",CHECK);
					result=3;
				}
			}break;
			case 2:{
				if (fp = GetProcAddress(hDLL,szConf)){
					szMsg = (char*)GlobalAlloc(GPTR,1000);
					if(argv[++i]){
						ConsoleYellow();
						if (!lstrcmp(argv[i],"pack")){
							printf("%s() <Pack>\n",CONF);
							resultbool = ((ConfigDialog)fp)(NULL,szMsg,2);
						}else{
							printf("%s() <Unpack>\n",CONF);
							resultbool = ((ConfigDialog)fp)(NULL,szMsg,1);
						}
					}else{
						ConsoleYellow();
						printf("%s() <Unpack>\n",CONF);
						resultbool = ((ConfigDialog)fp)(NULL,szMsg,1);
					}
					if (resultbool){
						ConsoleAqua();
						printf("Return: True\n");
						result=0;
					}else{
						ConsolePurple();
						printf("Return: False\n");
						result=2;
					}
					ConsoleWhite();
					printf("Output: %s",szMsg);
					GlobalFree(szMsg);
				}else{
					ConsoleRed();
					printf(JpCon
							?"%s() ̓T|[gĂ܂"
							:"%s() NOT supported.",CONF);
					result=3;
				}
			}break;
			case 3:{
				if (fp = GetProcAddress(hDLL,szCount)){
					ConsoleYellow();
					printf("%s()\n",COUNT);
					if(argv[++i]){
						result = ((GetFileCount)fp)(argv[i]);
						if (result==-1){
							ConsolePurple();
							printf(JpCon?"Ȃɂł":"Corrupted Archive.");
							result=2;
						}else{
							ConsoleAqua();
							printf("Count: %d",result);
							result=0;
						}
					}else{
						ConsoleRed();
						printf(JpCon
								?"ɂw肳Ă܂":"Archive is NOT Specified.");
						result=1;
					}
				}else{
					ConsoleRed();
					printf(JpCon
							?"%s() ̓T|[gĂ܂"
							:"%s() NOT supported.",COUNT);
					result=3;
				}
			}break;
			case 4:{
				if (fp = GetProcAddress(hDLL,szFunc)){
					ConsoleYellow();
					if(argv[++i]){
						printf("%s()",FUNC);
						printf(" <%s>\n",argv[i]);
						resultbool = ((QueryFunctionList)fp)(atoi(argv[i]));
						if (resultbool){
							ConsoleAqua();
							printf(JpCon?"@\͎gp\ł":"Function is supported.");
							result=0;
						}else{
							ConsolePurple();
							printf(JpCon?"@\͎gpł܂":"Function is NOT supported.");
							result=2;
						}
					}else{
						printf("%s\n",JpCon?"DLLŎgpł@\:":"Functions this library can use:");
						ConsoleAqua();
						for(i=0;i<100;i++){
							if(i==16||i==31||i==70) ConsoleYellow();
							if(i==23||i==40)		ConsoleAqua();
							if( ((QueryFunctionList)fp)(i) ) printf("%d\n",i);
						}
						result=0;
					}
				}else{
					ConsoleRed();
					printf(JpCon
							?"%s() ̓T|[gĂ܂"
							:"%s() NOT supported.",FUNC);
					result=3;
				}
			}break;
			case 5:{
				printf("Library Info:\n\n");
				ConsoleAqua();
				printf("%19s: ","Prefix");
				ConsoleYellow();
				printf("%s\n",szCmd);
				ConsoleAqua();
				printf("%17s(): ","GetBuild");
				ConsoleYellow();
					wsprintf(szFunc,"%s%s",szCmd,"GetBuild");
					(fp = GetProcAddress(hDLL,szFunc))
					 ?printf("%u\n",((Getversion)fp)()):printf("%s\n","-----");
				ConsoleAqua();
				printf("%17s(): ","GetCursorInterval");
				ConsoleYellow();
					wsprintf(szFunc,"%s%s",szCmd,"GetCursorInterval");
					(fp = GetProcAddress(hDLL,szFunc))
					 ?printf("%u\n",((Getversion)fp)()):printf("%s\n","-----");
				ConsoleAqua();
				printf("%17s(): ","GetCursorMode");
				ConsoleYellow();
					wsprintf(szFunc,"%s%s",szCmd,"GetCursorMode");
					printf("%s\n",(fp = GetProcAddress(hDLL,szFunc))
									?((GetRunning)fp)()?"TRUE":"FALSE"
									:"-----");
				ConsoleAqua();
				printf("%17s(): ","GetBackGroundMode");
				ConsoleYellow();
					wsprintf(szFunc,"%s%s",szCmd,"GetBackGroundMode");
					printf("%s\n",(fp = GetProcAddress(hDLL,szFunc))
									?((GetRunning)fp)()?"TRUE":"FALSE"
									:"-----");
				ConsoleAqua();
				printf("%17s(): ","GetRunning");
				ConsoleYellow();
					wsprintf(szFunc,"%s%s",szCmd,"GetRunning");
					printf("%s\n",(fp = GetProcAddress(hDLL,szFunc))
									?((GetRunning)fp)()?"TRUE":"FALSE"
									:"-----");
			}break;
			case 6:{
				FARPROC fp1 = GetProcAddress(hDLL,szOpen);
				FARPROC fp2 = GetProcAddress(hDLL,szFirst);
				FARPROC fp3 = GetProcAddress(hDLL,szNext);
						fp  = GetProcAddress(hDLL,szClose);

				if(fp1&&fp&&fp2&&fp3){
					if(argv[++i]){
						HARC hArc;
						ConsoleYellow();
 						printf("Listing of %s\n\n", argv[i]);
 						//printf("<Opening...> ");
						if(argv[++i])
							hArc=((OpenArchive)fp1)(NULL,argv[i-1],atoi(argv[i]));
						else
							hArc=((OpenArchive)fp1)(NULL,argv[i-1],0);
						if (hArc){
							int ncounts=0;
							INDIVIDUALINFO Info;
							DWORD dwOriginalSize = 0;
							DWORD dwCompressedSize = 0;
							int IsSFX;

							ConsoleGreen();

							//0NA
							NullMemory(&Info,sizeof(INDIVIDUALINFO));

 							//printf("<Listing...>\n\n");
/**************************************************/
//From test2.c. thx. shoda T.
	printf("Name Original   Compress  Ratio       Date     Time  Attrib    Type      CRC OS\n"
		   "%s\n",OpenLn);
	ConsoleAqua();
	if ( !((FindFirst)fp2)(hArc,"*",&Info) ){
		do{
			printf("%s\n"
                   "   %10u %10u %3d.%d%% %s %7s %7s %08X %02u\n",
				Info.szFileName, Info.dwOriginalSize, Info.dwCompressedSize,
				Info.wRatio/10,Info.wRatio%10,
				pszDateTimes(Info.wDate, Info.wTime),
				Info.szAttribute, Info.szMode,
				Info.dwCRC,Info.uOSType);
			dwOriginalSize += Info.dwOriginalSize;
			dwCompressedSize += Info.dwCompressedSize;
			ncounts++;
		}while ( !((FindNext)fp3)(hArc,&Info));
	ConsoleGreen();
	fp1 = GetProcAddress(hDLL,szRatio);
	fp2 = GetProcAddress(hDLL,szDate);
	fp3 = GetProcAddress(hDLL,szTime);
	if(fp1&&fp2&&fp3)
	printf("%s\n"
		   "   %10u %10u %3d.%d%% %s\n"
	       "(%u Files)\n\n",OpenLn,
			dwOriginalSize,dwCompressedSize,
			((GetArcDate)fp1)(hArc)/10,((GetArcDate)fp1)(hArc)%10,
			pszDateTimes( ((GetArcDate)fp2)(hArc),((GetArcDate)fp3)(hArc)),
			ncounts);
	else
	printf("%s\n"
		   "   %10u %10u\n"
	       "(%u Files)\n\n",OpenLn,
			dwOriginalSize,dwCompressedSize,
			ncounts);
	}
/**************************************************/
							if(fp1 = GetProcAddress(hDLL,szSfx)){
								switch(IsSFX = ((CloseArchive)fp1)(hArc)){
									case -1:
										ConsolePurple();
										printf("%s() Error.",SFX);
										break;
									case 0:
										ConsoleAqua();
										printf("%s()==0 %s",SFX,
											JpCon
											?"ʏ̏"
											:"This is a normal Archive.");
										break;
									default:
										ConsoleAqua();
										printf("%s()==%d %s",SFX,IsSFX,
											JpCon
											?"SFX"
											:"This is a SFX.");
										break;
								}
							}	
 							//printf("<Closing...>\n");
							((CloseArchive)fp)(hArc);
							//printf("<Listing OK.>");
							result=0;
						}else{
							ConsolePurple();
							printf(JpCon?"ɂĴɎs܂":"Failed to Open.");
							result=2;
						}
					}else{
						ConsoleRed();
						printf(JpCon
								?"ɂw肳Ă܂"
								:"Archive NOT specified.");
						result=1;
					}
				}else{
					ConsoleRed();
					printf(JpCon
							?"XeBO̓T|[gĂ܂"
							:"Listing NOT supported.");
					result=3;
				}
			}break;
			case 0:{
				char arg[FNAME_MAX32+10]; //10͂ĂƁ[B(^^;;;
				int j;
				char *szCommandLine;
				int size = 0;

				ConsoleYellow();
				printf("%s()\n",COM);
				//C֐

                if(!lstrcmp(szCmd,LMZIP32PRE)){
					if(argv[++i])
						if (!lstrcmp(argv[i],"a"))
							lstrcpy(szCmd,ZIP32JPRE);
				}
				i++;
				j=i;
				for (; i < argc; i++)
					size += lstrlen(argv[i]) + 3;
				szCommandLine = (char*)GlobalAlloc(GPTR,size+1);
				szCommandLine[0]='\0';
				for (i=j; i < argc; i++){
				//hǂ邽߂ɂ킴킴ȏ
					if (!SpaceThere(argv[i])){
						wsprintf(arg,"%s ",argv[i]);
						lstrcat(szCommandLine,arg);
					}else{
						wsprintf(arg,"\"%s\" ",argv[i]);
						lstrcat(szCommandLine,arg);}
				}
				ConsoleGreen();
				printf("Command Line: %s\n",szCommandLine);
				if (fp = GetProcAddress(hDLL,szCmd)){
					LARGE_INTEGER liStart, liEnd, liFreq;
					UINT64 ulTime;

					szMsg = (char*)GlobalAlloc(GPTR,65536);
					szMsg[0] = '\0';

					QueryPerformanceCounter(&liStart);
                	if (!lstrcmp(szCmd,"Ish")){
						if(fp = GetProcAddress(hDLL,"IshEx")){
							result = ((CmdIsh)fp)(szCommandLine, szMsg, 65535);
						}else{
							fp = GetProcAddress(hDLL,szCmd); //DmIsh32
							result = ((Command)fp)(NULL, szCommandLine, szMsg, 65535);
						}
					}else
						result = ((Command)fp)(NULL, szCommandLine, szMsg, 65535);
					QueryPerformanceCounter(&liEnd);
					QueryPerformanceFrequency(&liFreq);
					ulTime = (liEnd.QuadPart-liStart.QuadPart)*1000000/liFreq.QuadPart;

					ConsoleAqua();
					printf("Return Code: %X\nTime: %I64u.%06u\n\n",result,
								ulTime/1000000,(UINT)(ulTime%1000000));
					ConsoleWhite();
					print(szMsg);
					result=0;
					GlobalFree(szMsg);
				}else{
					ConsoleRed();
					printf(JpCon
							?"%s() ̓T|[gĂ܂"
							:"%s() NOT supported.",COM);
					result=3;
				}

				GlobalFree(szCommandLine);
			}break;
		}//switch.

	}else{ //if (hDLL==NULL)
		ConsoleRed();
		printerr(JpCon?"%s ͌܂ł":"%s NOT found.\n",argv[i]);
		result=2;
	};
	FreeLibrary( hDLL );
	if (bPause)
		Main_Pause();
	ConsoleEnd();
	return result;

}